#!/usr/bin/env python
# -*- coding: utf-8 -*-

from flask.ext.wtf import Form, FormField, TextField, PasswordField, BooleanField, FileField, RadioField, SelectField, SubmitField, validators
from flask.ext.wtf import ValidationError
import re

from eop import app
from fichier.passwd import check_nb_min_classes

class TestForm(Form):
    nomdev = TextField(u'Nom de référence', validators=[validators.required()])
    groupe = SelectField(u'Destinataires', choices=[])
    eleve_only = RadioField(u'Uniquement les élèves', default = "eleve", choices=[('eleve', u"Uniquement les élèves"), ('tous',u"À tous les membres")], coerce=unicode)

    rep_dest = RadioField(u"Répertoire de destination", default="perso", choices=[('perso', u"Distribuer immédiatement"), ('devoir', u"Distribuer plus tard")], coerce=unicode)

    submit = SubmitField(u'Valider')

class DocRamasserForm(Form):
    list_dev_a_ram = SelectField(u'Nom de la référence', choices=[])
    submit = SubmitField(u'Ramasser')

class DocRendreForm(Form):
    list_dev_a_ren = SelectField(u'Nom de la référence', choices=[])
    submit = SubmitField(u'Rendre')

class DocSupprimerForm(Form):
    list_dev_a_sup = SelectField(u'Nom de la référence', choices=[])
    submit = SubmitField(u'Supprimer')

def test_password(form, field):
    nb_car_min = app.config['NB_CAR_MIN']
    nb_classe_min = app.config['NB_CLASSE_MIN']
    mdp = field.data

    if len(mdp) < nb_car_min:
        raise ValidationError(u"Votre mot de passe doit comporter au moins %s caractères." % nb_car_min)

    if not check_nb_min_classes(mdp, nb_classe_min):
        raise ValidationError(u"Votre mot de passe doit être composé d'au moins %s classes de caractères." % nb_classe_min)

class ChangementMDPForm(Form):
    old_password = PasswordField(u'Ancien mot de passe ', validators=[validators.Required(message=u'Vous devez entrer votre ancien mot de passe.')])
    password = PasswordField(u'Nouveau mot de passe', validators=[validators.Required(message=u'Entrez votre nouveau mot de passe.'), test_password])
    re_password = PasswordField(u'Confirmation', validators=[validators.Required(message=u'Vous devez confirmer votre mot de passe.'), validators.EqualTo('password', message=u'Les mots de passe doivent correspondre.')])
    submit = SubmitField(u'Valider')
